<?php

namespace Sharplogicians\Keycloak\Controller\Login;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Controller\Result\RedirectFactory;
use Magento\Framework\App\Config\ScopeConfigInterface;

class Index extends Action
{
    protected $resultRedirectFactory;
    protected $scopeConfig;

    public function __construct(
        Context $context,
        RedirectFactory $resultRedirectFactory,
        ScopeConfigInterface $scopeConfig
    ) {
        $this->resultRedirectFactory = $resultRedirectFactory;
        $this->scopeConfig = $scopeConfig;
        parent::__construct($context);
    }

    public function execute()
    {
        $clientId = $this->scopeConfig->getValue('keycloak_sso/general/client_id');
        $baseUrl = $this->scopeConfig->getValue('keycloak_sso/general/keycloak_base_url');
        $realm = $this->scopeConfig->getValue('keycloak_sso/general/realm');
        $redirectUri = $this->_url->getUrl('keycloak/login/callback');

        $authUrl = $baseUrl . '/realms/' . $realm . '/protocol/openid-connect/auth'
            . '?client_id=' . $clientId
            . '&response_type=code'
            . '&redirect_uri=' . urlencode($redirectUri);

        $resultRedirect = $this->resultRedirectFactory->create();
        $resultRedirect->setUrl($authUrl);

        return $resultRedirect;
    }
}
